/*-
 * Copyright (C) @BABOLO  2002 Dec 17
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2002 Dec 17\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cmd_perform.c,v 1.2 2002/12/23 02:04:38 babolo Exp $";
#endif /* not lint */
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <libpq-fe.h>
#include "pgm.h"
#include "pgoblin.h"

int
perform(struct connopt *options, FILE *in, char *query) {
    PGresult *res;
    char *q;

    if  (v_flag > 3) fprintf( stderr, "+perform %s in=%s query=%s\n"
                            , options->query ? options->query : ""
                            , in ? "OK" : "NULL"
                            , query ? query : "NULL"
                            );
    if  (shurecon(options))                                                                return(-1);
    if  (query) q = query;
    else if (in) {
        if  ((q = prefile(in, NULL, NULL)) == NULL)                                        return(-1);
    } else if (options->query) q = options->query;
    else {                                   if (v_flag >= 0) warnx("perform: No query"); return(-1);}

    if  (*q == '#') {
        q = index(q, '\n');
        if  (!q) {                   if (v_flag >= 0) warnx("perform: No query after #"); return(-1);}
        q++;
    }
    PQEXEC(res, q, PGRES_COMMAND_OK, -1);
    PQclear(res);
    if  (v_flag > 3)                                             fprintf( stderr, "-perform %d\n", 0);
    return(0);
}
